int X_Axis = A0;             // select the input pin for the sensor
int Y_Axis = A1; 
int Z_Axis = A2;
float X_reference_Value=0;
float Y_reference_Value=0;
float Z_reference_Value=0;
int X_Axis_Value = 0;           
int Y_Axis_Value = 0;
int Z_Axis_Value = 0;
void setup() {

   int i;
   float X_sum=0,Y_sum=0,Z_sum=0;
   pinMode(X_Axis, INPUT);
   pinMode(Y_Axis, INPUT);
   pinMode(Z_Axis, INPUT);
   Serial.begin(9600);
   Serial.println("Please do not rotate it before calibrate!");
   Serial.println("Get the reference value:");
    
   for(i=0;i<1000;i++)
   {
       // read the value from the sensor:
       X_Axis_Value = analogRead(X_Axis);
       Y_Axis_Value = analogRead(Y_Axis);
       Z_Axis_Value = analogRead(Z_Axis);
       X_sum += X_Axis_Value;
       Y_sum += Y_Axis_Value;
       Z_sum += Z_Axis_Value;
       delay(5);
   }
   X_reference_Value = X_sum/1000.0;
   Y_reference_Value = Y_sum/1000.0;
   Z_reference_Value = Z_sum/1000.0;
   Serial.print("reference_Value:   ");
   Serial.print("X:");
   Serial.print(X_reference_Value);
   Serial.print("  Y:");
   Serial.print(Y_reference_Value);
   Serial.print("  Z:");
   Serial.println(Z_reference_Value);
   Serial.println("Now you can begain your test!");
}

void loop() 
{
   double X_angularVelocity,Y_angularVelocity,Z_angularVelocity;
   X_Axis_Value = analogRead(X_Axis);
   Y_Axis_Value = analogRead(Y_Axis);
   Z_Axis_Value = analogRead(Z_Axis);
   X_angularVelocity =((double)(X_Axis_Value-X_reference_Value)*4930.0)/1023.0/0.67; //get the angular velocity
   Y_angularVelocity =((double)(Y_Axis_Value-Y_reference_Value)*4930.0)/1023.0/0.67;
   Z_angularVelocity =((double)(Z_Axis_Value-Z_reference_Value)*4930.0)/1023.0/0.67;
   Serial.print("angularVelocity:  ");
   Serial.print("X:");
   Serial.print(X_angularVelocity);
   Serial.print("deg/s");
   Serial.print("   Y:");
   Serial.print(Z_angularVelocity);
   Serial.print("deg/s");
  Serial.print("   Z:");
   Serial.print(Z_angularVelocity);
   Serial.print("deg/s");
   Serial.println(" ");
   delay(500);
}
